<?php
namespace Controllers;

use \Zeedhi\Framework\Report\ReportService;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DTO\Request\Row;

class FaturamentoCompanhia extends \Zeedhi\Framework\Controller\Report {

    protected $environment;
    protected $dataSourceManager;
    protected $birtStrategy;

    public function __construct(ReportService $reportService, $environment, $dataSourceManager, $birtStrategy) {
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->birtStrategy = $birtStrategy;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'FAC00500' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "DTINICIAL" => "DTINI",
                "DTFINAL"   => "DTFIN",
                "CDCIA"     => "CDCIA",
                "CDFILIAL"  => "CDFILIAL",
                "VOO"       => "NRVOO",
                "CLASSE"    => "CDCLASSE",
                "NRORG"     => "NRORG"
            ),
            'reportName'
        ),
        'FAC00501' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "DTINICIAL" => "DTINI",
                "DTFINAL"   => "DTFIN",
                "CDCIA"     => "CDCIA",
                "CDFILIAL"  => "CDFILIAL",
                "VOO"       => "NRVOO",
                "CLASSE"    => "CDCLASSE",
                "NRORG"     => "NRORG"
            ),
            'reportName'
        ),
        'FAC00502' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "DTINICIAL" => "DTINI",
                "DTFINAL"   => "DTFIN",
                "CDCIA"     => "CDCIA",
                "CDFILIAL"  => "CDFILIAL",
                "VOO"       => "NRVOO",
                "CLASSE"    => "CDCLASSE",
                "NRORG"     => "NRORG"
            ),
            'reportName'
        ),
        'FAC00507' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "DTINICIAL" => "P_DATAINI",
                "DTFINAL"   => "P_DATAFIM",
                "CDCIA"     => "P_CDCIA",
                "CDFILIAL"  => "P_CDFILIAL",
                "VOO"       => "P_VOOS",
                "CLASSE"    => "P_CLASSES",
                "NRORG"     => "NRORG"
            ),
            'reportName'
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {

        $row = $request->getRow();
        $row['NRORG']  = $this->environment->getNrOrgTrab();
        $row['__report_name'] = $row['REPORTNAME'];
        $this->birtStrategy->setReportFormat($row['REPORTFORMAT']);
    }
    
}